// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: SummaryDischargeAndFuelingDataResponse.proto

package ru.omnicomm.pegasus.messaging.data.responses;

public final class SummaryRefuelingResponseParser {
  private SummaryRefuelingResponseParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public enum State
      implements com.google.protobuf.ProtocolMessageEnum {
    NORMAL(0, 0),
    LAST(1, 1),
    DEFECTIVE(2, 2),
    ;
    
    
    public final int getNumber() { return value; }
    
    public static State valueOf(int value) {
      switch (value) {
        case 0: return NORMAL;
        case 1: return LAST;
        case 2: return DEFECTIVE;
        default: return null;
      }
    }
    
    public static com.google.protobuf.Internal.EnumLiteMap<State>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static com.google.protobuf.Internal.EnumLiteMap<State>
        internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<State>() {
            public State findValueByNumber(int number) {
              return State.valueOf(number)
    ;        }
          };
    
    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      return getDescriptor().getValues().get(index);
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.getDescriptor().getEnumTypes().get(0);
    }
    
    private static final State[] VALUES = {
      NORMAL, LAST, DEFECTIVE, 
    };
    public static State valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      return VALUES[desc.getIndex()];
    }
    private final int index;
    private final int value;
    private State(int index, int value) {
      this.index = index;
      this.value = value;
    }
    
    static {
      ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.getDescriptor();
    }
    
    // @@protoc_insertion_point(enum_scope:ru.omnicomm.pegasus.messaging.data.responses.State)
  }
  
  public static final class SummaryDischargeAndFuelingDataResponse extends
      com.google.protobuf.GeneratedMessage {
    // Use SummaryDischargeAndFuelingDataResponse.newBuilder() to construct.
    private SummaryDischargeAndFuelingDataResponse() {
      initFields();
    }
    private SummaryDischargeAndFuelingDataResponse(boolean noInit) {}
    
    private static final SummaryDischargeAndFuelingDataResponse defaultInstance;
    public static SummaryDischargeAndFuelingDataResponse getDefaultInstance() {
      return defaultInstance;
    }
    
    public SummaryDischargeAndFuelingDataResponse getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_fieldAccessorTable;
    }
    
    public static final class Row extends
        com.google.protobuf.GeneratedMessage {
      // Use Row.newBuilder() to construct.
      private Row() {
        initFields();
      }
      private Row(boolean noInit) {}
      
      private static final Row defaultInstance;
      public static Row getDefaultInstance() {
        return defaultInstance;
      }
      
      public Row getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_Row_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_Row_fieldAccessorTable;
      }
      
      // required double totalValue = 101;
      public static final int TOTALVALUE_FIELD_NUMBER = 101;
      private boolean hasTotalValue;
      private double totalValue_ = 0D;
      public boolean hasTotalValue() { return hasTotalValue; }
      public double getTotalValue() { return totalValue_; }
      
      // required double totalDischargeValue = 102;
      public static final int TOTALDISCHARGEVALUE_FIELD_NUMBER = 102;
      private boolean hasTotalDischargeValue;
      private double totalDischargeValue_ = 0D;
      public boolean hasTotalDischargeValue() { return hasTotalDischargeValue; }
      public double getTotalDischargeValue() { return totalDischargeValue_; }
      
      // required double totalFillingValue = 103;
      public static final int TOTALFILLINGVALUE_FIELD_NUMBER = 103;
      private boolean hasTotalFillingValue;
      private double totalFillingValue_ = 0D;
      public boolean hasTotalFillingValue() { return hasTotalFillingValue; }
      public double getTotalFillingValue() { return totalFillingValue_; }
      
      // required double totalDrainValue = 104;
      public static final int TOTALDRAINVALUE_FIELD_NUMBER = 104;
      private boolean hasTotalDrainValue;
      private double totalDrainValue_ = 0D;
      public boolean hasTotalDrainValue() { return hasTotalDrainValue; }
      public double getTotalDrainValue() { return totalDrainValue_; }
      
      private void initFields() {
      }
      public final boolean isInitialized() {
        if (!hasTotalValue) return false;
        if (!hasTotalDischargeValue) return false;
        if (!hasTotalFillingValue) return false;
        if (!hasTotalDrainValue) return false;
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (hasTotalValue()) {
          output.writeDouble(101, getTotalValue());
        }
        if (hasTotalDischargeValue()) {
          output.writeDouble(102, getTotalDischargeValue());
        }
        if (hasTotalFillingValue()) {
          output.writeDouble(103, getTotalFillingValue());
        }
        if (hasTotalDrainValue()) {
          output.writeDouble(104, getTotalDrainValue());
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (hasTotalValue()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(101, getTotalValue());
        }
        if (hasTotalDischargeValue()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(102, getTotalDischargeValue());
        }
        if (hasTotalFillingValue()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(103, getTotalFillingValue());
        }
        if (hasTotalDrainValue()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(104, getTotalDrainValue());
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder> {
        private ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row result;
        
        // Construct using ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row.newBuilder()
        private Builder() {}
        
        private static Builder create() {
          Builder builder = new Builder();
          builder.result = new ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row();
          return builder;
        }
        
        protected ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row internalGetResult() {
          return result;
        }
        
        public Builder clear() {
          if (result == null) {
            throw new IllegalStateException(
              "Cannot call clear() after build().");
          }
          result = new ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row();
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(result);
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row.getDefaultInstance();
        }
        
        public boolean isInitialized() {
          return result.isInitialized();
        }
        public ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row build() {
          if (result != null && !isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return buildPartial();
        }
        
        private ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          if (!isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return buildPartial();
        }
        
        public ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row buildPartial() {
          if (result == null) {
            throw new IllegalStateException(
              "build() has already been called on this Builder.");
          }
          ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row returnMe = result;
          result = null;
          return returnMe;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row other) {
          if (other == ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row.getDefaultInstance()) return this;
          if (other.hasTotalValue()) {
            setTotalValue(other.getTotalValue());
          }
          if (other.hasTotalDischargeValue()) {
            setTotalDischargeValue(other.getTotalDischargeValue());
          }
          if (other.hasTotalFillingValue()) {
            setTotalFillingValue(other.getTotalFillingValue());
          }
          if (other.hasTotalDrainValue()) {
            setTotalDrainValue(other.getTotalDrainValue());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  return this;
                }
                break;
              }
              case 809: {
                setTotalValue(input.readDouble());
                break;
              }
              case 817: {
                setTotalDischargeValue(input.readDouble());
                break;
              }
              case 825: {
                setTotalFillingValue(input.readDouble());
                break;
              }
              case 833: {
                setTotalDrainValue(input.readDouble());
                break;
              }
            }
          }
        }
        
        
        // required double totalValue = 101;
        public boolean hasTotalValue() {
          return result.hasTotalValue();
        }
        public double getTotalValue() {
          return result.getTotalValue();
        }
        public Builder setTotalValue(double value) {
          result.hasTotalValue = true;
          result.totalValue_ = value;
          return this;
        }
        public Builder clearTotalValue() {
          result.hasTotalValue = false;
          result.totalValue_ = 0D;
          return this;
        }
        
        // required double totalDischargeValue = 102;
        public boolean hasTotalDischargeValue() {
          return result.hasTotalDischargeValue();
        }
        public double getTotalDischargeValue() {
          return result.getTotalDischargeValue();
        }
        public Builder setTotalDischargeValue(double value) {
          result.hasTotalDischargeValue = true;
          result.totalDischargeValue_ = value;
          return this;
        }
        public Builder clearTotalDischargeValue() {
          result.hasTotalDischargeValue = false;
          result.totalDischargeValue_ = 0D;
          return this;
        }
        
        // required double totalFillingValue = 103;
        public boolean hasTotalFillingValue() {
          return result.hasTotalFillingValue();
        }
        public double getTotalFillingValue() {
          return result.getTotalFillingValue();
        }
        public Builder setTotalFillingValue(double value) {
          result.hasTotalFillingValue = true;
          result.totalFillingValue_ = value;
          return this;
        }
        public Builder clearTotalFillingValue() {
          result.hasTotalFillingValue = false;
          result.totalFillingValue_ = 0D;
          return this;
        }
        
        // required double totalDrainValue = 104;
        public boolean hasTotalDrainValue() {
          return result.hasTotalDrainValue();
        }
        public double getTotalDrainValue() {
          return result.getTotalDrainValue();
        }
        public Builder setTotalDrainValue(double value) {
          result.hasTotalDrainValue = true;
          result.totalDrainValue_ = value;
          return this;
        }
        public Builder clearTotalDrainValue() {
          result.hasTotalDrainValue = false;
          result.totalDrainValue_ = 0D;
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.SummaryDischargeAndFuelingDataResponse.Row)
      }
      
      static {
        defaultInstance = new Row(true);
        ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.internalForceInit();
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.SummaryDischargeAndFuelingDataResponse.Row)
    }
    
    // required int32 messageType = 2;
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 0;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // optional string instanceId = 4;
    public static final int INSTANCEID_FIELD_NUMBER = 4;
    private boolean hasInstanceId;
    private java.lang.String instanceId_ = "";
    public boolean hasInstanceId() { return hasInstanceId; }
    public java.lang.String getInstanceId() { return instanceId_; }
    
    // repeated .ru.omnicomm.pegasus.messaging.data.responses.SummaryDischargeAndFuelingDataResponse.Row rows = 201;
    public static final int ROWS_FIELD_NUMBER = 201;
    private java.util.List<ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row> rows_ =
      java.util.Collections.emptyList();
    public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row> getRowsList() {
      return rows_;
    }
    public int getRowsCount() { return rows_.size(); }
    public ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row getRows(int index) {
      return rows_.get(index);
    }
    
    // optional .ru.omnicomm.pegasus.messaging.data.responses.State blockState = 300;
    public static final int BLOCKSTATE_FIELD_NUMBER = 300;
    private boolean hasBlockState;
    private ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.State blockState_;
    public boolean hasBlockState() { return hasBlockState; }
    public ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.State getBlockState() { return blockState_; }
    
    // optional int32 blockNumber = 301;
    public static final int BLOCKNUMBER_FIELD_NUMBER = 301;
    private boolean hasBlockNumber;
    private int blockNumber_ = 0;
    public boolean hasBlockNumber() { return hasBlockNumber; }
    public int getBlockNumber() { return blockNumber_; }
    
    private void initFields() {
      blockState_ = ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.State.NORMAL;
    }
    public final boolean isInitialized() {
      if (!hasMessageType) return false;
      for (ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row element : getRowsList()) {
        if (!element.isInitialized()) return false;
      }
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasInstanceId()) {
        output.writeString(4, getInstanceId());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row element : getRowsList()) {
        output.writeMessage(201, element);
      }
      if (hasBlockState()) {
        output.writeEnum(300, getBlockState().getNumber());
      }
      if (hasBlockNumber()) {
        output.writeInt32(301, getBlockNumber());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasInstanceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeStringSize(4, getInstanceId());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row element : getRowsList()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(201, element);
      }
      if (hasBlockState()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(300, getBlockState().getNumber());
      }
      if (hasBlockNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(301, getBlockNumber());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse result;
      
      // Construct using ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        if (result.rows_ != java.util.Collections.EMPTY_LIST) {
          result.rows_ =
            java.util.Collections.unmodifiableList(result.rows_);
        }
        ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse other) {
        if (other == ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.getDefaultInstance()) return this;
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasInstanceId()) {
          setInstanceId(other.getInstanceId());
        }
        if (!other.rows_.isEmpty()) {
          if (result.rows_.isEmpty()) {
            result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row>();
          }
          result.rows_.addAll(other.rows_);
        }
        if (other.hasBlockState()) {
          setBlockState(other.getBlockState());
        }
        if (other.hasBlockNumber()) {
          setBlockNumber(other.getBlockNumber());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 34: {
              setInstanceId(input.readString());
              break;
            }
            case 1610: {
              ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row.Builder subBuilder = ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addRows(subBuilder.buildPartial());
              break;
            }
            case 2400: {
              int rawValue = input.readEnum();
              ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.State value = ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.State.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(300, rawValue);
              } else {
                setBlockState(value);
              }
              break;
            }
            case 2408: {
              setBlockNumber(input.readInt32());
              break;
            }
          }
        }
      }
      
      
      // required int32 messageType = 2;
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 0;
        return this;
      }
      
      // optional string instanceId = 4;
      public boolean hasInstanceId() {
        return result.hasInstanceId();
      }
      public java.lang.String getInstanceId() {
        return result.getInstanceId();
      }
      public Builder setInstanceId(java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  result.hasInstanceId = true;
        result.instanceId_ = value;
        return this;
      }
      public Builder clearInstanceId() {
        result.hasInstanceId = false;
        result.instanceId_ = getDefaultInstance().getInstanceId();
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.data.responses.SummaryDischargeAndFuelingDataResponse.Row rows = 201;
      public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row> getRowsList() {
        return java.util.Collections.unmodifiableList(result.rows_);
      }
      public int getRowsCount() {
        return result.getRowsCount();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row getRows(int index) {
        return result.getRows(index);
      }
      public Builder setRows(int index, ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.rows_.set(index, value);
        return this;
      }
      public Builder setRows(int index, ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row.Builder builderForValue) {
        result.rows_.set(index, builderForValue.build());
        return this;
      }
      public Builder addRows(ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row value) {
        if (value == null) {
          throw new NullPointerException();
        }
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row>();
        }
        result.rows_.add(value);
        return this;
      }
      public Builder addRows(ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row.Builder builderForValue) {
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row>();
        }
        result.rows_.add(builderForValue.build());
        return this;
      }
      public Builder addAllRows(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row> values) {
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row>();
        }
        super.addAll(values, result.rows_);
        return this;
      }
      public Builder clearRows() {
        result.rows_ = java.util.Collections.emptyList();
        return this;
      }
      
      // optional .ru.omnicomm.pegasus.messaging.data.responses.State blockState = 300;
      public boolean hasBlockState() {
        return result.hasBlockState();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.State getBlockState() {
        return result.getBlockState();
      }
      public Builder setBlockState(ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.State value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.hasBlockState = true;
        result.blockState_ = value;
        return this;
      }
      public Builder clearBlockState() {
        result.hasBlockState = false;
        result.blockState_ = ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.State.NORMAL;
        return this;
      }
      
      // optional int32 blockNumber = 301;
      public boolean hasBlockNumber() {
        return result.hasBlockNumber();
      }
      public int getBlockNumber() {
        return result.getBlockNumber();
      }
      public Builder setBlockNumber(int value) {
        result.hasBlockNumber = true;
        result.blockNumber_ = value;
        return this;
      }
      public Builder clearBlockNumber() {
        result.hasBlockNumber = false;
        result.blockNumber_ = 0;
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.SummaryDischargeAndFuelingDataResponse)
    }
    
    static {
      defaultInstance = new SummaryDischargeAndFuelingDataResponse(true);
      ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.SummaryDischargeAndFuelingDataResponse)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_Row_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_Row_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n,SummaryDischargeAndFuelingDataResponse" +
      ".proto\022,ru.omnicomm.pegasus.messaging.da" +
      "ta.responses\"\206\003\n&SummaryDischargeAndFuel" +
      "ingDataResponse\022\023\n\013messageType\030\002 \002(\005\022\022\n\n" +
      "instanceId\030\004 \001(\t\022g\n\004rows\030\311\001 \003(\0132X.ru.omn" +
      "icomm.pegasus.messaging.data.responses.S" +
      "ummaryDischargeAndFuelingDataResponse.Ro" +
      "w\022H\n\nblockState\030\254\002 \001(\01623.ru.omnicomm.peg" +
      "asus.messaging.data.responses.State\022\024\n\013b" +
      "lockNumber\030\255\002 \001(\005\032j\n\003Row\022\022\n\ntotalValue\030e",
      " \002(\001\022\033\n\023totalDischargeValue\030f \002(\001\022\031\n\021tot" +
      "alFillingValue\030g \002(\001\022\027\n\017totalDrainValue\030" +
      "h \002(\001*,\n\005State\022\n\n\006NORMAL\020\000\022\010\n\004LAST\020\001\022\r\n\t" +
      "DEFECTIVE\020\002BN\n,ru.omnicomm.pegasus.messa" +
      "ging.data.responsesB\036SummaryRefuelingRes" +
      "ponseParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_descriptor,
              new java.lang.String[] { "MessageType", "InstanceId", "Rows", "BlockState", "BlockNumber", },
              ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.class,
              ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_Row_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_descriptor.getNestedTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_Row_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_SummaryDischargeAndFuelingDataResponse_Row_descriptor,
              new java.lang.String[] { "TotalValue", "TotalDischargeValue", "TotalFillingValue", "TotalDrainValue", },
              ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row.class,
              ru.omnicomm.pegasus.messaging.data.responses.SummaryRefuelingResponseParser.SummaryDischargeAndFuelingDataResponse.Row.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  public static void internalForceInit() {}
  
  // @@protoc_insertion_point(outer_class_scope)
}
